import os
import msvcrt
import threading
import sqlite3
import random
from operator import itemgetter

conn = sqlite3.connect('records.db')
cursor = conn.cursor()
lose = False


def clear():
    os.system('cls')


def write():
    clear()
    for el in line:
        stroka = ''
        for elem in el:
            stroka += elem
        print(stroka)
    print('Ф - влево, В - вправо, Пробел - выстрел')
    print('Ваш счёт:', counter)
    if lose is False:
        fps = threading.Timer(0.05, write)
        fps.start()


def right():
    flag = True
    global counter
    for i in range(0, len(line[-1])):
        if line[-1][i] == '@' and i + 1 != len(line[-1]) and flag is True:
            if line[-1][i + 1] == '#':
                counter += 1
            line[-1][i] = '.'
            line[-1][i + 1] = '@'
            flag = False


bulletsonair = False


def laser():
    global bulletsonair
    global counter
    for i in range(0, len(line[-2])):
        if line[-1][i] == '@':
            if line[-2][i] == '#':
                counter += 1
                line[-2][i] = '.'
            else:
                line[-2][i] = 'I'
    if bulletsonair is False:
        t = threading.Timer(1.0, laserflight)
        t.start()
        bulletsonair = True


def enemymotion():
    global lose
    global counter
    for y in range(-1, len(line) * -1, -1):
        for z in range(0, len(line[y])):
            if y < -1 and line[y][z] == '#':
                if line[y + 1][z] != 'I' and line[y + 1][z] != '@':
                    line[y + 1][z] = '#'
                    line[y][z] = '.'
                elif line[y + 1][z] == '@':
                    line[y][z] = '.'
                    counter += 1
            elif y == -1 and line[y][z] == '#':
                line[y][z] = '.'
                lose = True
                break
    if lose is False:
        ten = threading.Timer(5.0, enemymotion)
        ten.start()


def laserflight():
    for i in range(0, len(line)):
        for x in range(0, len(line[i])):
            if i > 0 and line[i][x] == 'I':
                if line[i - 1][x] == '#':
                    global counter
                    line[i - 1][x] = '.'
                    line[i][x] = '.'
                    counter += 1
                else:
                    line[i - 1][x] = 'I'
                    line[i][x] = '.'
            elif i == 0 and line[i][x] == 'I':
                line[i][x] = '.'
    t = threading.Timer(1.0, laserflight)
    t.start()


def records():
    global lose
    proverka = cursor.execute(f"""SELECT * FROM records WHERE name = '{name}'""").fetchone()
    if proverka is None:
        cursor.execute(f"""INSERT INTO records VALUES('{name}', {counter})""")
        conn.commit()
    else:
        if proverka[-1] < counter:
            cursor.execute(f"""UPDATE records SET record = {counter} WHERE name = '{name}'""")
    clear()
    print(f'Ваш счёт:{counter}')
    recs = cursor.execute("SELECT * From records").fetchall()
    recs.sort(key=itemgetter(-1), reverse=True)
    if len(recs) > 5:
        for res in range(0, 4):
            print(f'{recs[res][0]}....{recs[res][-1]}')
    else:
        for res in recs:
            print(f'{res[0]}....{res[-1]}')
    print('Нажмите Пробел чтобы начать заново')
    while lose is True:
        pressedkey = msvcrt.getch()
        if ord(pressedkey) == 32:
            lose = False
            game()


def respawnenemy():
    for i in range(0, len(line[0])):
        num = random.randint(0, 1)
        if num == 1:
            line[1][i] = '#'
    if lose is False:
        respawm = threading.Timer(20.0, respawnenemy)
        respawm.start()


def left():
    global counter
    for i in range(0, len(line[-1])):
        if line[-1][i] == '@' and i != 0:
            if line[-1][i - 1] == '#':
                counter += 1
            line[-1][i] = '.'
            line[-1][i - 1] = '@'


def game():
    global line
    global counter
    counter = 0
    line = [['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '#', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
            ['.', '.', '.', '.', '.', '.', '.', '.', '@', '.', '.', '.', '.', '.', '.', '.', '.']]
    write()
    enemymotion()
    respawnenemy()
    while lose is False:
        pressedkey = msvcrt.getch()
        if ord(pressedkey) == ord('a') or ord(pressedkey) == 228:
            left()
        elif ord(pressedkey) == ord('d') or ord(pressedkey) == 162:
            right()
        elif ord(pressedkey) == 32:
            laser()
    if lose is True:
        clear()
        records()


print('Введите ваше имя')
name = input()
counter = 0
line = [['#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#'],
        ['.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.', '#', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '#', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.', '.'],
        ['.', '.', '.', '.', '.', '.', '.', '.', '@', '.', '.', '.', '.', '.', '.', '.', '.']]
game()
